<?php
/*
 * Copyright (c) 2016, Tribal Limited
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Zenario, Tribal Limited nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL TRIBAL LTD BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

function adminId() {
	if (session('admin_logged_into_site') && session('admin_logged_into_site') == COOKIE_DOMAIN. SUBDIRECTORY. setting('site_id')) {
		return session('admin_userid');
	} else {
		return false;
	}
}

//Check for an admin priv
//	function checkPriv($action = false, $editCID = false, $editCType = false, $editCVersion = 'latest') {}

//	function exitIfNotCheckPriv($action = false, $editCID = false, $editCType = false, $editCVersion = 'latest') {}

//Get an Admin Phrase
//	function adminPhrase($code, $replace = array()) {}

//Gets a list of pagination options for modules
function paginationOptions() {
	$options = array();
	
	foreach (getRunningModules() as $module) {
		if (getPluginPaginationTypesFromDescription($module['class_name'], $paginationTypes)) {
			foreach ($paginationTypes as $type => $label) {
				$options[$type] = (string) $label;
			}
		}
	}
	
	asort($options, SORT_STRING);
	return $options;
}

//Get the value of an admin's setting
function adminSetting($settingName) {
	if (!isset(cms_core::$adminSettings[$settingName])) {
		cms_core::$adminSettings[$settingName] =
			getRow('admin_settings', 'value', array('name' => $settingName, 'admin_id' => adminId()));
		
		if (cms_core::$adminSettings[$settingName] === false) {
			cms_core::$adminSettings[$settingName] =
				getRow('admin_setting_defaults', 'default_value', $settingName);
		}
	}
	return cms_core::$adminSettings[$settingName];
}

//Change an admin's setting
function setAdminSetting($settingName, $value) {
	
	if (!adminId()) {
		return;
	}
	
	cms_core::$adminSettings[$settingName] = $value;
	
	setRow('admin_settings', array('value' => $value), array('name' => $settingName, 'admin_id' => adminId()));
}